ifeq ($(findstring darwin, $(GNUSTEP_TARGET_OS)), darwin)
  # For Vector
  ADDITIONAL_LDFLAGS += -framework Accelerate -faltivec
  # Only for Darwin 
  ADDITIONAL_CFLAGS += -mdynamic-no-pic -falign-loops=16
endif

#
# Runtime tool (aka ioVM)
#

ADDITIONAL_INCLUDE_DIRS += \
        -Iiovm \
        -Ibasekit \
        -Iskipdb \
        -Igarbagecollector \
        -Icoroutine \
        -IVector \
        -IObjcBridge

TOOL_NAME = ioobjc

ioobjc_SUBPROJECTS += \
	basekit \
	coroutine \
        garbagecollector \
	skipdb \
	iovm \
	Vector \
	ObjcBridge

ioobjc_OBJC_FILES = \
	main.m

ifeq ($(FOUNDATION_LIB), apple)
  ioobjc_OBJC_LIBS += -framework AppKit
else
  # in order to access gui classes from tool.
  ioobjc_OBJC_LIBS += -lgnustep-gui
endif

include $(GNUSTEP_MAKEFILES)/tool.make

